osg::TemplatePrimitiveIndexFunctor< T > Class Template Reference

`#include <TemplatePrimitiveIndexFunctor>`

Inheritance diagram for osg::TemplatePrimitiveIndexFunctor< T >:

## Public Member Functions

| TemplatePrimitiveIndexFunctor ()
virtual | ~TemplatePrimitiveIndexFunctor ()
virtual void | setVertexArray (unsigned int, const Vec2 *)
virtual void | setVertexArray (unsigned int, const Vec3 *)
virtual void | setVertexArray (unsigned int, const Vec4 *)
virtual void | setVertexArray (unsigned int, const Vec2d *)
virtual void | setVertexArray (unsigned int, const Vec3d *)
virtual void | setVertexArray (unsigned int, const Vec4d *)
virtual void | drawArrays (GLenum mode, GLint first, GLsizei count)
virtual void | drawElements (GLenum mode, GLsizei count, const GLubyte *indices)
virtual void | drawElements (GLenum mode, GLsizei count, const GLushort *indices)
virtual void | drawElements (GLenum mode, GLsizei count, const GLuint *indices)
Public Member Functions inherited from osg::PrimitiveIndexFunctor
virtual | ~PrimitiveIndexFunctor ()

## Detailed Description

template<class T>
class osg::TemplatePrimitiveIndexFunctor< T >

Provides access to the primitives that compose an `osg::Drawable`.

Notice that `TemplatePrimitiveIndexFunctor` is a class template, and that it inherits from its template parameter `T`. This template parameter must implement operator()(const osg::Vec3 v1, const osg::Vec3 v2, const osg::Vec3 v3, bool treatVertexDataAsTemporary), operator()(const osg::Vec3 v1, const osg::Vec3 v2, bool treatVertexDataAsTemporary), operator()(const osg::Vec3 v1, const osg::Vec3 v2, const osg::Vec3 v3, bool treatVertexDataAsTemporary), and operator()(const osg::Vec3 v1, const osg::Vec3 v2, const osg::Vec3 v3, const osg::Vec3 v4, bool treatVertexDataAsTemporary) which will be called for the matching primitive when the functor is applied to a `Drawable`. Parameters `v1`, `v2`, `v3`, and `v4` are the vertices of the primitive. The last parameter, `treatVertexDataAsTemporary`, indicates whether these vertices are coming from a "real" vertex array, or from a temporary vertex array, created by the `TemplatePrimitiveIndexFunctor` from some other geometry representation.

See also
  `PrimitiveFunctor` for general usage hints.

## Constructor & Destructor Documentation

## TemplatePrimitiveIndexFunctor()

template<class T>

osg::TemplatePrimitiveIndexFunctor< T >::TemplatePrimitiveIndexFunctor | ( |  | ) |

inline

## ~TemplatePrimitiveIndexFunctor()

template<class T>

virtual osg::TemplatePrimitiveIndexFunctor< T >::~TemplatePrimitiveIndexFunctor | ( |  | ) |

inline virtual

## Member Function Documentation

## drawArrays()

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::drawArrays | ( | GLenum | mode,
|  | GLint | first,
|  | GLsizei | count )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## drawElements() [1/3]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::drawElements | ( | GLenum | mode,
|  | GLsizei | count,
|  | const GLubyte * | indices )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## drawElements() [2/3]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::drawElements | ( | GLenum | mode,
|  | GLsizei | count,
|  | const GLuint * | indices )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## drawElements() [3/3]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::drawElements | ( | GLenum | mode,
|  | GLsizei | count,
|  | const GLushort * | indices )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [1/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec2 * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [2/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec2d * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [3/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec3 * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [4/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec3d * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [5/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec4 * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

## setVertexArray() [6/6]

template<class T>

virtual void osg::TemplatePrimitiveIndexFunctor< T >::setVertexArray | ( | unsigned int | ,
|  | const Vec4d * | )

inline virtual

Implements osg::PrimitiveIndexFunctor.

The documentation for this class was generated from the following file:

- TemplatePrimitiveIndexFunctor